# --*-PERL-*--
#####################################################################
#
# Copyright 1996, CyberCash Inc. All rights reserved.
# Written by Brian Boesch and Judy Grass
# Modified by Gene Gotimer
#
# These routines are intended to be used exclusively with the 
# CyberCash secure payment system.
#
# RCSID: $Id: CCMckErrno3_2.pm,v 1.3 1998/03/30 21:24:10 grass Exp $
#
# Error codes and messages
#
# Do not redistribute without written permission from CyberCash Inc.
######################################################################

package CCMckErrno3_2;

require 5.003;

require Exporter;
@ISA = (Exporter);
@EXPORT = qw();
@EXPORT_OK = qw(MCKGetErrorMessage $E_NoErr $E_ERROR

    $E_Alarm_Failed    $E_BadCont_Len    $E_BadMethod       $E_Bad_Amount 
    $E_Bad_Config      $E_Bad_Currency   $E_Bad_Orderid     $E_Bad_Params 
    $E_Bad_Payload     $E_Bad_Timeout    $E_Bad_Url         $E_Big_Amount
    $E_Browser         $E_Cash_Register  $E_ConnectFailed   $E_Crypto
    $E_DNS_Failed      $E_DecryptFailed  $E_EncryptFailed   $E_Fail_Notif
    $E_Failed_HTTP     $E_GoAway         $E_MAC_Compare     $E_MF_Signature
    $E_Neg_Amount      $E_No_Cont_Len    $E_No_File
    $E_No_Get          $E_No_MAC         $E_No_Memory 
    $E_No_POP          $E_No_Post        $E_No_Amount       $E_No_CashReg
    $E_No_Config       $E_No_Key         $E_No_Message      $E_No_Method
    $E_No_NotifLog     $E_No_OrderLog    $E_No_Orderid      $E_No_Pay_Page 
    $E_No_Payload      $E_No_Receipt     $E_No_Skey        
    $E_No_SSL          $E_No_Template
	$E_Not_HTTP 
    $E_Null_Config     $E_Null_Msg       $E_Null_Result     $E_Order_NotFound
    $E_Order_NotSaved  $E_Payment_Failed $E_POP_Signature  
	$E_Read_Template   $E_Reject_Currency 
    $E_SignatureFailed $E_SocketFailed   $E_Sockopt_Failed  $E_Stat_Failed 
    $E_SyswriteFailed  $E_TimedOut
	$E_CPI_Signature   $E_MO_Signature
 );

# Load error constants
$E_NoErr = 0;
$CC_ERRBASE = -300;

	#Generic unknown error
$E_ERROR = $CC_ERRBASE;

	# Errors in the request for CGI service
$E_No_Post      = $CC_ERRBASE - 1;
$E_No_Cont_Len  = $CC_ERRBASE - 2;
$E_BadCont_Len = $CC_ERRBASE - 3;
$E_Null_Msg    = $CC_ERRBASE - 4;
$E_No_Method   = $CC_ERRBASE - 5;
$E_No_Get       = $CC_ERRBASE - 6;
$E_BadMethod   = $CC_ERRBASE - 7;

	#narrow use: indicates incompatible browser
$E_Browser    = $CC_ERRBASE - 8;

	#Errors in the content of the request
$E_No_Amount   = $CC_ERRBASE - 10;
$E_Bad_Amount  = $CC_ERRBASE - 11;
$E_Big_Amount  = $CC_ERRBASE - 12;
$E_Neg_Amount  = $CC_ERRBASE - 13;
$E_Bad_Currency = $CC_ERRBASE - 14;
$E_Reject_Currency = $CC_ERRBASE - 15;
 
$E_No_Orderid  = $CC_ERRBASE - 16;
$E_Bad_Orderid  = $CC_ERRBASE - 17;
 
$E_No_Payload  = $CC_ERRBASE - 18;
$E_Bad_Payload  = $CC_ERRBASE - 19;


	#Protocol errors
$E_No_SSL      = $CC_ERRBASE - 30;
$E_Bad_Url     = $CC_ERRBASE - 31;
$E_Not_HTTP    = $CC_ERRBASE - 32;
$E_Failed_HTTP = $CC_ERRBASE - 33;
$E_No_CashReg  = $CC_ERRBASE - 34;
$E_No_Message  = $CC_ERRBASE - 35;

	#Socket woes
$E_SocketFailed   = $CC_ERRBASE - 40;
$E_ConnectFailed  = $CC_ERRBASE - 41;
$E_DNS_Failed     = $CC_ERRBASE - 42;
$E_Alarm_Failed   = $CC_ERRBASE - 43; 
$E_Sockopt_Failed = $CC_ERRBASE - 44;
$E_SyswriteFailed = $CC_ERRBASE - 45;

	#Configuration problems
$E_No_Config      = $CC_ERRBASE - 50;
$E_Null_Config    = $CC_ERRBASE - 51;
$E_Bad_Config     = $CC_ERRBASE - 52;
$E_Bad_Timeout    = $CC_ERRBASE - 53;

	#Cash Register response problems
$E_GoAway      = $CC_ERRBASE - 60;
$E_TimedOut    = $CC_ERRBASE - 61;
$E_No_POP       = $CC_ERRBASE - 62;
$E_POP_Signature  = $CC_ERRBASE - 63;
$E_MF_Signature  = $CC_ERRBASE - 64;
$E_Cash_Register = $CC_ERRBASE - 65;
$E_SignatureFailed = $CC_ERRBASE - 66;
$E_Payment_Failed = $CC_ERRBASE - 67;
$E_CPI_Signature  = $CC_ERRBASE - 68;
$E_MO_Signature  = $CC_ERRBASE - 69;

	#system problems -- probably not relevant to PERL
	# But for the sake of keeping in synch with other code
$E_No_Memory		= $CC_ERRBASE - 70;
$E_Stat_Failed  = $CC_ERRBASE - 71;

	#Crypto problems
$E_No_Key      = $CC_ERRBASE - 80;
$E_Crypto      = $CC_ERRBASE - 81;
$E_MAC_Compare = $CC_ERRBASE - 82;
$E_EncryptFailed = $CC_ERRBASE - 83;
$E_DecryptFailed = $CC_ERRBASE - 84;
$E_No_Skey       = $CC_ERRBASE - 85;
$E_No_MAC        = $CC_ERRBASE - 86;

	
    # Miscellaneous problems 
$E_No_Template    = $CC_ERRBASE - 90;    # Can't open the template 
$E_Read_Template  = $CC_ERRBASE - 91;  # Can't read the template 
$E_No_OrderLog    = $CC_ERRBASE - 92;  # Can't open the order log 
$E_Order_NotFound = $CC_ERRBASE - 93;  # Can't find the order 
$E_Order_NotSaved = $CC_ERRBASE - 94;  # Can't record the order 
$E_Null_Result    = $CC_ERRBASE - 95;  # No result record passed in 
$E_Bad_Params     = $CC_ERRBASE - 96;  # Improper argument to function 
$E_No_NotifLog    = $CC_ERRBASE - 97;  # Can't open the notification log
 
$E_No_Pay_Page    = $CC_ERRBASE - 98;  # Can't gen payment page 
$E_Fail_Notif     = $CC_ERRBASE - 99;  # Notification failed 
$E_No_File        = $CC_ERRBASE - 100;  # Can't open file
$E_No_Receipt     = $CC_ERRBASE - 101;  # Can't open receipt template
 


%CCErrorMsgs = (
	$E_NoErr       => "OK",
	$E_ERROR       => "Unspecified Error",
	$E_No_Post      => "Expecting HTTP POST message",
	$E_No_Cont_Len  => "No Content-length",
	$E_BadCont_Len => "Bad Content-length",
	$E_Null_Msg    => "POST message body empty",
	$E_No_Method   => "No HTTP request method specified",
	$E_No_Get       => "Expecting HTTP GET request",
	$E_BadMethod   => "Unexpected HTTP request method",

	$E_Browser    => "Unsupported browser",

	$E_No_Amount   => "No price/amount specified",
	$E_Bad_Amount  => "Invalid price/amount specified",
	$E_Big_Amount  => "Price/amount specified is too large",
	$E_Neg_Amount  => "Price/amount specified is negative or zero",
	$E_Bad_Currency => "Currency specified is invalid",
	$E_Reject_Currency => "Currency specified is not accepted",
 
	$E_No_Orderid  => "No Order Id specified",
	$E_Bad_Orderid  => "Invalid Order Id specified",
 
	$E_No_Payload  => "Cannot open/read payload",
	$E_Bad_Payload  => "Invalid payload",


	$E_No_SSL      => "SSL is unsupported for direct connect",
	$E_Bad_Url     => "URL is malformed",
	$E_Not_HTTP    => "Invalid HTTP response",
	$E_Failed_HTTP => "HTTP request failed",
	$E_No_CashReg  => "missing Cash Register Host or Port",
	$E_No_Message  => "missing message for CCSocketSend",

	$E_SocketFailed   => "system socket() failed",
	$E_ConnectFailed  => "system socket connect() failed",
	$E_DNS_Failed     => "Unable to resolve host name",
	$E_Alarm_Failed   => "Unix Alarm failure",
	$E_Sockopt_Failed => "system setsockopt() failed",
	$E_SyswriteFailed => "socket write() failed",

	$E_No_Config      => "Cannot open MCK Configuration file",
	$E_Null_Config    => "MCK Configuration is not initialized",
	$E_Bad_Config     => "MCK Configuration file has syntax errors",
	$E_Bad_Timeout    => "Invalid timeout value (<= 0)",

	$E_GoAway      => "Server rejected request",
	$E_TimedOut    => "Server request timed out",
	$E_No_POP       => "No POP record returned for payment request",
	$E_POP_Signature  => "Proof-of-purchase (POP) signature error",
	$E_MF_Signature  => "Merchant data (MF) signature error",
	$E_Cash_Register => "Problem at the Cash Register",
	$E_SignatureFailed => "Signature error",
	$E_Payment_Failed => "Payment Failed",
	$E_MO_Signature  => "Merchant Order (MO) signature error",
	$E_CPI_Signature  => "Payment Instrument (CPI) signature error",

	$E_No_Memory		=> "Out of memory",
	$E_Stat_Failed  => "stat() on file failed",

	$E_No_Key      => "No merchant encryption key",
	$E_Crypto      => "Failure in Cryptographic library",
	$E_MAC_Compare => "Message MACs are not identical",
	$E_EncryptFailed => "MCKenrypt failed",
	$E_DecryptFailed => "MCKdecrypt failed",
	$E_No_Skey       => "Missing Session Key",
	$E_No_MAC        => "Missing MAC",

	$E_No_Template    => "Cannot open template",
	$E_Read_Template  => "Failure while reading template",
	$E_No_OrderLog    => "Cannot open the Order Log",
	$E_Order_NotFound => "Order not found",
	$E_Order_NotSaved => "Order not saved",
	$E_Null_Result    => "Unexpected Null result",
	$E_Bad_Params     => "Invalid parameters for function call",
	$E_No_NotifLog    => "Cannot open Notification Log",
 
	$E_No_Pay_Page    => "Failed to generate a Payment Page",
	$E_Fail_Notif     => "Unable to Log this transaction",
	$E_No_File        => "Unable to open file",
	$E_No_Receipt     => "Payment successful, failed to generate receipt",
 
);


sub MCKGetErrorMessage
{
	my($errcode) = @_;
	
	if (defined $CCErrorMsgs{$errcode}) {
		return $CCErrorMsgs{$errcode};
	}

	return "Unknown Error";
}

1;
