#!/usr/bin/perl
#   $Id: mswalletpay.cgi,v 1.25 1998/12/11 18:02:46 grass Exp $
#
#   System     :   Merchant Connection Kit (MCK)
#
#   Author     :   CYCH Development staff
#   Description:   CGI script to do MSWallet Credit Card payment
#
#   Notes      :   This may be edited to integrate with the merchant's
#                   storefront
#
#                         COPYRIGHT NOTICE
#
#   The contents of this file is protected under the United States
#   copyright laws as an unpublished work, and is confidential and
#   proprietary to CyberCash, Inc.  Its use or disclosure in whole or in
#   part without the expressed written permission of CyberCash, Inc. is
#   prohibited.
#
#   (c) Copyright 1993-98 by CyberCash, Inc.  All rights reserved.
#
###########################
#
# mswalletpay.cgi
#    This script is launched when a consumer decides to buy something.
#     This services *ONLY* credit sales made either with Microsoft
#     wallet, or without use of a wallet and payment information must
#     be entered manually.
#     This script must be under SSL access... e.g. do not send
#     card data over the web in the clear
#
###########################


    # 
    # Check Perl version
    #
require 5.003;

    #
    # Require some libraries:  either install these where PERL can find them,
	#   or add code to push the directory where they live...
    #


# The following 4 lines are here only because the current directory for
# Microsoft IIS when running script on browser is always the root
# directory of the web server.
BEGIN {
     push(@INC, '/home/httpd/test-store/cgi-bin/mck-cgi');
     push(@INC, '/home/httpd/test-store/cgi-bin/mck-cgi/');
}

use CCMckLib3_2 qw($MCKversion  %Config
	InitConfig CCError CCDebug CCDebug2 GetQuery 
	LoadBlockFromQuery BuildSignature
	GeneratePaymentPage Browser PrintTemplate StringTemplate);

use CCMckErrno3_2 qw(MCKGetErrorMessage $E_NoErr
	$E_SignatureFailed
	);

use CCMerchantTest qw($ConfigFile TemplateFailure);
use CCMerchantCustom qw(ReadPaymentInfo);


##################
#  
#  Some data initializations....
#
##################

 
# Initialize the Global Configuration array in CCMckLib3_2
($status) = &InitConfig($ConfigFile);

if ($status != 0) {
	$errmsg = &MCKGetErrorMessage($status);
    &TemplateFailure($errmsg);

	# since logging isn't possible, call die and try to get the web server
	# to log this problem
    die("$0: $errmsg.\n");
}


&CCDebug("Entering $0\n");

$cybercashId = $Config{"CYBERCASH_ID"};
$hashSecret = $Config{"HASH_SECRET"};
$templateDir = $Config{"TEMPLATE_DIR"};
$redirectURL = $Config{"REDIRECT_URL"};

	# A Note about message fields in paymentNVList.
	#    paymentNVList holds message parameters 
	#    that will be embedded in the payment page
	#  
	# These parameters are broken into three blocks according to
	# a prefix in the argument field name.
	#
	# prefix                 use
	#
	#  mo.        -- data driving the Cash Register 
	#                 this include Payment data and some operational options
	#  mf.        -- anything additional you want to pass on to the 
	#                  Fulfillment Center

$problemTemplate =  $templateDir . "tempDifficulties.tem";

#############################
#  MAIN code starts here    #
#############################

	# get the query string
%query = &GetQuery;

	
	#Read the order-id from the message

	# Data on the payment page is unsigned.  Don't put anything there that the
	# customer could alter if you cannot validate it somehow.

$orderId = $query{'mo.order-id'};
$paymentNVList{'mo.order-id'} = $orderId; 

	#  Get Order Info from the order log...
	#   For DISPLAY purposes only...
    #  This uses the test version of an order log
    #  The test version will not scale to large stores.
    #  You will need to replace this function with one that makes
    #  sense for *your* storefront

	# This routine logs, reports and exits if there is an error
   
    ($timestamp, $price, $orderValidTill, $payload,
            $customerId, $product) = &ReadPaymentInfo ($orderId);

	# write HTML page to browser that contains an order-id 

	# This must go over an SSL link to secure sensitive information
	# In this case, the sensitive data is the Credit Card info this
	# payment page will collect

    #Load any MF fields that may be in the query
    #This will copy any query field with "mf." prefix into the payment vector
 
%paymentNVList = &LoadBlockFromQuery("mf", \%query, \%paymentNVList);
 
    #add anything additional you like to this message,
    # It will be used during fulfillment 
# $paymentNVList{'mf.your-field-here'} = "some value";

	# Order-id is unsigned.  Presumably there is no incentive to alter it.
	# No card info present, so no CPI to sign
 
	# If a signature is present, the directpaycredit.cgi will check it,
	# and the signed block will be passed on to any remote fulfillment center
	
	# Adding a signature only makes sense if you can check the signature at
	# the FulFillment Center 
	# Note that any data you collect on the Payment Page is unsigned!

$paymentNVList{'mf.sign'} = &BuildSignature("mf", $hashSecret, %paymentNVList);


	#############################
	# Generate the Payment Page #
	#############################

# At this point, all of the data that needs to go into the "Payment Page"
# should have been collected.
#
# generatePaymentPage is going to package up the data in the paymentNVList
# and embed it in your payment template.
#
# We will load this token, if it is present in your template:
#
#	#MANUAL_ARGS#     which is the name value pairs from the paymentNVlist
#                      formed into blocks and coded as a series of HTML form 
#                      hidden input statements.  These are used as parameters
#                      for an HTML form.
#                     
#                      Your template may add additional input parameters
#
#  You may define additional tokens in your template if you wish.  If you
#  add their values to %templateNVlist, your tokens will be replaced
#  as well as ours.
#
# example: you added a token named #quoteOfThDay# to your template
#    make this assignment to replace it with your desired value:
#      $templateNVList{"quoteOfThDay"} = "I think, therefore I am";
#

# Do not move or delete the following 8 lines
# URL for the empty.wlt file
$dummy_mswallet = $Config{"MSW_DUMMY_URL"};

#
# Include some variables for the ActiveX and Plugin
#
require 'msw.pl';

# If the broswer is MS Wallet compatible, pick up the right object version,
# ActiveX or Plugin
%browser = &Browser();
$netscape = 0;
$useMSW = 0;
$creditOBJ = ' '; 
if ($browser{'platform'} =~ /win32/) {
    if ($browser{'type'} =~ /MSIE|Internet Explorer/i) {
        if ($browser{'version'} => 3.0) {
            $creditOBJ = $credit{'ActiveX'};
            $useMSW = 1; # set MS Wallet flag 
        }
    } elsif ($browser{'type'} =~ /Mozilla/i) {
        if ($browser{'version'} => 3.0) {
            $creditOBJ = $credit{'Plugin'};
            $netscape = 1;
            $useMSW = 1; # set MS Wallet flag 
        }
    }
}

# Only window based browsers, including netscape 3.0 and up and
# Internet Explorer 3.0 and up, are Microsoft Wallet compatible.
# If it is MS Wallet compatible, set the payment page to mswPayment.tem,
# If it is not, set the payment page to cardPayment.tem which is used for  
# a no-wallet transaction

if ($useMSW) {
        $paymentTemplate = $templateDir . "mswPayment.tem";
}
else {
        $paymentTemplate = $templateDir . "cardPayment.tem";
}

# ready to do MS Wallet specific tasks 
if ($useMSW) {
   %templateNVList = 
		&SetUpMswPaymentPage(\%templateNVList, $creditOBJ, 
			$price, $orderId, $product, $netscape); 
}

$status = &GeneratePaymentPage( $paymentTemplate, 
				\%templateNVList, \%paymentNVList);

if ($status != 0) {
	# This is the only way that this can fail, 
	#  other than the user pulling the plug.

	$errmsg = &MCKGetErrorMessage($status);
	$templatePrms{'MESSAGE'} = $errmsg;

    &CCError("$0: $errmsg ($paymentTemplate)");
	$errcode = &PrintTemplate($problemTemplate, %templatePrms);
	if ($errcode != $E_NoErr) {
		&TemplateFailure($errmsg);
	}
    exit 1;
}

	#
	# Now, store any information you might want to have later:
	# shipping address, customer number, any information stored
	# in the shopping cart (like what the customer ordered!!), etc.
	# 

&CCDebug ("Exiting $0\n");

exit 0;


# This subroutine formats information for the mswPayment page

sub SetUpMswPaymentPage {
   my($templateNVListRef, $creditOBJ, 
		$price, $orderid, $product, $netscape)=@_;
   my($msw_accepts, @cards_accepted, $onsubmit, $mswjs, $mswjsPath);
   my($status, $errmsg);
   my(%tempNVList);

   %tempNVList = %$templateNVListRef;

   # Get accepts from configuration file
   $msw_accepts = $Config{"MSW_ACCEPTS"};
   @cards_accepted = split(',',${msw_accepts});
   foreach $card (@cards_accepted) {
      push(@accept,"${card}:clear");
   }
   $accepts = join(';',@accept);

   $mswjs = '';
   $onsubmit = '';

   # Build a list of tokens for substitution in creditOBJ
   %token = ( 'price'    => $price,
              'accepts'  => $accepts,
              'netscape' => $netscape);

   $list = join('|', keys %token);

   # Then, read creditOBJ and substitute valid tokens
   while ($creditOBJ =~ /\#($list)\#/o) {
      $creditOBJ =~ s//$token{$1}/;
   }

   # Read mswjs.tem to a buffer

   $mswjsPath = $Config{"TEMPLATE_DIR"} . "mswjs.tem";
   ($status, $mswjs) = &StringTemplate($mswjsPath, %token);
	
	if ($status != $E_NoErr) {
		$errmsg = &MCKGetErrorMessage($status);
		$templatePrms{'MESSAGE'} = $errmsg;
	
	    &CCError("$0: $errmsg ($mswjsPath)");
		$errcode = &PrintTemplate($problemTemplate, %templatePrms);
		if ($errcode != $E_NoErr) {
			&TemplateFailure($errmsg);
		}
	    exit 1;
	}

   # If you change the name of CCPrepareForm() in mswjs.tem, or
   # change the name of form mswform in the mswPayment.tem, you
   # have to change the following line accordingly.

   $onsubmit= "onSubmit=\"return CCPrepareForm(document.mswform, $netscape)\"";

   $tempNVList{'CREDIT'} = $creditOBJ;
   $tempNVList{'MSWJS'} = $mswjs;
   $tempNVList{'ONSUBMIT'} = $onsubmit;
   $tempNVList{'price'} = $price;
   $tempNVList{'order_id'} = $orderid;
   $tempNVList{'product'} = $product;

   return (%tempNVList);
}

