###########################
# Lib containing all cells#
# in the Checkout Process #
###########################
#
#
# Version 0.9.22 20000922 TG
#    Re-wrote new_addr
# Version 0.9.21 20000915
#    Oracle integration
# Version 0.9.20 20000822
#    Bug fixes to error messages
# Version 0.9.19 20000807
#    Bug fixes
# Version 0.9.18 20000730
#    Add condition if no shipping
# Version 0.9.17 20000727
#    Bug fixes
# Version 0.9.16 20000717
#    Fixed weight calculation
# Version 0.9.15 20000711
#    Additional variant fix
# Version 0.9.14 20000709
#    Fixed variant title display
# Version 0.9.13 20000706
#    Fixed shipping from showing up as product 
# Version 0.9.12 20000629 JN
#    Fixed address enter error message display
# Version 0.9.11 20000622
#    Fixed Shipping Method stuff
# Version 0.9.10 20000614
#    Fixed the address enter thing for the page_addressenter
# Version 0.9.9 20000614
#    Jumped a few, but just removed some print statements
# Version 0.9.6 20000613
#    Fixed upper case ADDRID to lowercase
#    Fixed reload bug with address enter
# Version 0.9.4 20000525
#    Cleaned up
# Version 0.9.0 20000302
#    Hash out all functions



###########
#   Cell List           function
#   Addressbook cell        cl_addressbook()
#   EnterAddress cell       cl_addressenter()
#   Orderlist cell          cl_orderlist()
#   Shiping Method cell     cl_shippingmethod()
###########

###########
#   Transfer Hash
#   Key                 Descript
#   ERROR                   scalar, null if no errors
#   (FIELDNAME)             scalar, Database pull
#   oid                 scalar, order id
#   sid                 scalar, session id
#   custnum                 scalar, custumer #
#   mode                    scalar, requested mode
#   templatename                scalar, template string
###########


sub cl_addressbook {
   
   ###########
   # cl_addressbook 		small cell which displays addressbook LIST
   #
   # Requires
   # 	uid
   #	sid
   #
   # This cell uses cell cell_ck_addressbook_(function name)
   # function name is for now either billto or shipto
   # this is mainly to allow name changes for functionality
   #
   my $ret_hash = $_[0];
   my ($rows,$template,$template_name,$addrid_type,$tmp_cell,$h,$tmp_output,$q);
   $addrid_type = $ret_hash->{'addrid_type'};
   $template_name = "cell_ck_addressbook_" . $addrid_type;
   # lets get the addrids for the uid first (myhome)
   # this should be by custnum but myhome doesn't store
   if ($ret_hash->{'mode'} eq 'SHOW') {
      
      
      $q = "SELECT * FROM addresses WHERE custid = " . $dbh->quote($ret_hash->{'custid'});
      $sth=$dbh->prepare($q);
      $sth->execute;
#      $rows = $sth->rows;
#      if ($rows <= 0) {
         ## no addresses, don't display
#         return $ret_hash;
#         } else {
      
#	  for (1 .. $rows) {
            # now the meat of the cell
#            $template = localize_template($template_name, $om_render_lang,"html",0);
#            $h = $sth->fetchrow_hashref(NAME_lc); ## get all the data from addresses
#            $h->{'backpage'} = $ret_hash{'DISPLAY'}; ## change the return
#            ($h->{'firstname'} , $h->{'lastname'},$h->{'nametitle'}) = split /\|/ , $h->{'name'}; ## split up name into First and last and nametitle
#            $h->{'addrid'}=$h->{'objid'};
#            $tmp_cell = permutebit ($template,$h); ## permute the cell
#            $tmp_output .= $tmp_cell;
#         }
#      }
      $ok=0;
      while ($h = $sth->fetchrow_hashref(NAME_lc)) {
          $ok=1;
         $template = localize_template($template_name, $om_render_lang,"html",0);
#         $h = $sth->fetchrow_hashref(NAME_lc); ## get all the data from addresses
         $h->{'backpage'} = $ret_hash{'DISPLAY'}; ## change the return
         ($h->{'firstname'} , $h->{'lastname'},$h->{'nametitle'}) = split /\|/ , $h->{'name'}; ## split up name into First and last and nametitle
         $h->{'addrid'}=$h->{'objid'};
         $tmp_cell = permutebit ($template,$h); ## permute the cell
         $tmp_output .= $tmp_cell;

     }
     if ( $ok == 1 ) {

         } else {

         ## no addresses, don't display
         return $ret_hash; 

      }      



      $sth->finish;
      
      } elsif ($ret_hash->{'mode'} eq 'APPROVE' && $ret_hash->{'FORM'}->{'cell'} eq 'addressbook') {
      ## this was to delete addresses, this probably needs to be changed to merely mark the status or flag
      ## as deleted
      
      if ($ret_hash->{'FORM'}->{'func'} eq 'delete' && $ret_hash->{'FORM'}->{'cell'} eq 'addressbook') {
         #validate Addrid
         #
         #trip if addrid is registry addrid
         $q = "delete from addresses where objid = ". $dbh->quote($ret_hash->{'FORM'}->{'addrid'}) . " and custid = " . $dbh->quote($custid); # uid is myhome spec
         
#         $dbh->do($q);
         $sth = $dbh->prepare( $q );
         $sth->execute;
      }
      
   }
   
   $ret_hash->{'FORM'}->{'cell_ck_addressbook'} = $tmp_output;
   return $ret_hash;
}


sub cl_addressedit {
   
   ##################
   # cl_addressedit
   #
   #
   # this is an addressedit form element
   # cell name is cell_ck_addressenter
   
   my $ret_hash = $_[0];
   my ($template,$order,$q,$h,$tmp_cellhash,$tmp_output,$rows,$tmp_addrid);
   ## SHOW
   ## permute cell with hash values if they exist. As well if oid or addrid exists see if we can fill in the data
   ## that way
   
   ## we need to setup tmp_addrid so that we'll edit it if we get one
   ## otherwise we're creating a new one
    
   if ($ret_hash->{'addrid'}) { $tmp_addrid = $ret_hash->{'addrid'}; }
   if ($ret_hash->{'FORM'}->{'addrid'}) { $tmp_addrid = $ret_hash->{'FORM'}->{'addrid'};}
   
   
   if ($ret_hash->{'mode'} eq 'SHOW') {
      $tmp_state='';
      ## we need to split up the name again
      ($ret_hash->{'FORM'}->{'firstname'},$ret_hash->{'FORM'}->{'lastname'},$ret_hash->{'FORM'}->{'nametitle'}) = split /\|/, $ret_hash->{'FORM'}->{'name'};
      
      $template = localize_template("cell_ck_addressenter", $om_render_lang, "html",0);
      if (($ret_hash->{'FORM'}->{'func'} =~ /billto|shipto/) && (!$tmp_addrid)) {
         ## if our func was billto or shipto and we don't have an addrid lets get one
         
         if ($ret_hash->{'orderid'}) {
            $q = "SELECT $ret_hash->{'FORM'}->{'func'} FROM orders WHERE orderid = " . $dbh->quote($ret_hash->{'orderid'});
           
            $sth=$dbh->prepare($q);
            $sth->execute;
#            $rows=$sth->rows;
#            if ($rows == 1) {
#               my $tmp = $sth->fetchrow;
            if ( my $tmp = $sth->fetchrow ) {
               $tmp_addrid = $tmp if ($tmp);
            } ##TODO add else for more than one return
            $sth->finish;
         }
      }
      if ($tmp_addrid && $ret_hash->{'FORM'}->{'load'}) {
         ## now if we have the form element load we want to load that addrid, this is hardcoded for now but can be
         ## made into a submit button
         $q = "SELECT * FROM addresses WHERE objid = " . $dbh->quote($tmp_addrid);
         $sth=$dbh->prepare($q);
         $sth->execute;
#         $rows=$sth->rows;
#         if ($rows == 1){
         if ( $tmp_cellhash = $sth->fetchrow_hashref(NAME_lc) ) {
#            $tmp_cellhash = $sth->fetchrow_hashref(NAME_lc);
         }
         $tmp_cellhash->{'addrid'} = $tmp_cellhash->{'objid'};
         $tmp_state=$tmp_cellhash->{'state'};

         ## we don't really need to pull the state from but I thought it made things clearer
         $sth->finish;
         } elsif ($ret_hash->{'FORM'}->{'load'} || $ret_hash->{'ERROR'}) {
         foreach $k (keys %{$ret_hash->{'FORM'}}) {
            $tmp_cellhash->{$k} = $ret_hash->{'FORM'}->{$k};
         }
         $tmp_state=$tmp_cellhash->{'state'};
         ## again we didn't really have to do this, but i think it made it clearer for debugging
      }

      ($tmp_cellhash->{'firstname'},$tmp_cellhash->{'lastname'},$tmp_cellhash->{'nametitle'}) = split /\|/ ,$tmp_cellhash->{'name'};
      ## generate the state pulldown
      
      $q=localize_template( "sel_state", $om_render_lang, "html" ,0 );
      @temp=split /\n/,$q;
      $tmp_cell->{'STATE_SELECT'} = gen_select( $tmp_state,2,@temp );
      if ($ret_hash->{'custid'} eq $tmp_cellhash->{'custid'} || !$tmp_addrid || $ret_hash->{'ERROR'} ) {
         $tempout = permutebit ($template,$tmp_cellhash);
	     $tempout = permutebit ($tempout,$tmp_cell);

      } else {
         $ret_hash->{'addrid'} = '';
         $ret_hash->{'FORM'}->{'addrid'} = ''; 
	     $tempout = permutebit ($template,$tmp_cell);
	     $tempout = permuteclean ($tempout);
      }
      ## permute all that to the template
      $ret_hash->{'FORM'}->{'cell_ck_addressenter'} = $tempout;
      ## put that into ret_hash
      } elsif ($ret_hash->{'mode'} eq 'APPROVE' && $ret_hash->{'FORM'}->{'func'} =~ /addressedit|shipto|billto/) {
      
      
      ## APPROVE
      
      ## send through validate
      ## if ok, check if addrid exists in FORM
      ## if it does update that entery if not
      ## get a new addrid and enter data into it
      
      my ($change);
      $change = 0;
      ## this stuff is for validation that you actually changed something
      foreach $k (keys %{$ret_hash->{'FORM'}}){
         next if ($k !~ /pre$/);
         ## now that all wee have is _pre's ...
         if ($k eq 'firstname_pre' && !$ret_hash->{'FORM'}->{$k}) {
            ## hack when form is empty and you submited through addressbook
            ## this is for cases when you use an old address and it hasn't been split on pipes
            $skip = 1;
         }
         $k =~ s/_pre//;
         ## we set change to 1 so that we can check on it
         $change = 1 if ($ret_hash->{'FORM'}->{$k.'_inp'} ne $ret_hash->{'FORM'}->{$k.'_pre'});
      }

      foreach $k (keys %{$ret_hash->{'FORM'}}) {
         ## now lets figure out if they already have an addrid they want to use
         next if ($k !~ /^KEYADDRID/);
         @tmp = split /\./, $k;
         $ret_hash->{'FORM'}->{'addrid'}	= $tmp[1];
      }
      if ($skip) {$change = 0;}
      if ((!$ret_hash->{'addrid'} && !$ret_hash->{'FORM'}->{'addrid'}) || $change) {
         ## if we don't have any addressids or we're changing go through here
          
         $ret_hash->{'FORM'}->{'name'} = $ret_hash->{'FORM'}->{'firstname_inp'} . '|' . $ret_hash->{'FORM'}->{'lastname_inp'} . '|' .$ret_hash->{'FORM'}->{'nametitle_inp'};
         $tmp_cellhash =  validateaddr( $ret_hash->{'FORM'} );
         ## we created a new tmp_cellhash because validateaddr (from the library) messes up the hash
         $tmp_cellhash->{'ERROR'} = $tmp_cellhash->{'errors'};
         if (!$tmp_cellhash->{'errors'}) {
            ## if we don't have any errors we update or add the address
            $tmp_cellhash->{'custid'} = $ret_hash->{'custid'};
            $tmp_cellhash->{'sid'} = $ret_hash->{'sid'};
            $tmp_cellhash->{'addrid'} = $ret_hash->{'FORM'}->{'addrid'};
            $tmp_cellhash->{'custnum'} = $ret_hash->{'custnum'};
            $tmp_addrid = new_addr($tmp_cellhash);
            if ($tmp_addrid ne '0') {
               $ret_hash->{'addrid'} = $tmp_addrid;
               $ret_hash->{'FORM'}->{'addrid'}= $tmp_addrid; 
  
            }
         } else {
            ## we had errors
            foreach $key (keys %{$tmp_cellhash}) {
               ## remember tmp_cellhash came from new_addr and the validator
               ## so we have to put the things back into ret_hash so we can display the errors
               $nkey = $key;
               $ret_hash->{'FORM'}->{$key} = $tmp_cellhash->{$key} if ($tmp_cellhash->{$key});
               $nkey =~ s/_inp//;
               if ($nkey eq 'name') {
                  ## ugh deal with the name again
                  ($ret_hash->{'FORM'}->{'firstname'},$ret_hash->{'FORM'}->{'lastname'},$ret_hash->{'FORM'}->{'nametitle'}) = split /\|/ , $tmp_cellhash->{$key};
                  } else {
                  $ret_hash->{'FORM'}->{$nkey} = $tmp_cellhash->{$key} if ($tmp_cellhash->{$key});
               }

           }
            $ret_hash->{'ERROR'} = $tmp_cellhash->{'ERROR'};
         }
      }
   }
   return $ret_hash;
}

sub cl_shippingmethod {
   
   ##################
   # cl_shippingmethod
   # this chooses the shping method
   #
   my ($h,$q,$now,$ret_hash,$unitwt);
   $ret_hash = $_[0];
   $now = time();
   if ($ret_hash->{'mode'} eq 'SHOW') {
      ##SHOW
      $shipnum =1;
      foreach $orderid (@{$ret_hash->{'orderid_array'}}) {

   ## we do this once for each oid
         $tmp_cart_cell = localize_template("cell_ck_cartdisplay", $om_render_lang, "html",0);
         
         $tmp_address_cell = localize_template("cell_ck_addresslist_shipto", $om_render_lang, "html",0);
         $tmp_shippingmethod_cell = '';
         $tmp_shippingmethod_cell = localize_template("cell_ck_shippingmethod", $om_render_lang, "html",0);
         $tmp_output='';

         $q="SELECT lineobjid,quant FROM tcart WHERE orderid='$orderid' AND objclass != '140-A'";
         $sts=$dbh->prepare( $q );
         $sts->execute;
#         foreach ( 1..$sts->rows ) {

#            $h = $sts->fetchrow_hashref(NAME_lc);
         while ( $h = $sts->fetchrow_hashref(NAME_lc) ) {
            $wlineobjid=$h->{'lineobjid'};
            $q="SELECT body FROM extraprop WHERE objid='$wlineobjid' AND fieldname='weight'";
            $stq=$dbh->prepare( $q );
            $stq->execute;
            $unitwt = $stq->fetchrow;
            $unitwt = (split/\|/, $unitwt)[0];
            $weight += ( $h->{'quant'} * $unitwt );

         } # done looping through the cart contents     

        $q = "UPDATE orders SET shipwt='$weight' WHERE objid='$orderid'";
        $stq=$dbh->prepare($q);
        $stq->execute;     
             
         $weight=1.0 if ( $weight < 1.0 );
     
         ## get the destination address
         #
         $q = "SELECT * FROM orders WHERE objid=" . $dbh->quote($orderid);
         $sts=$dbh->prepare( $q );
         $sts->execute;
#         if ( $sts->rows > 0 ) {
#            $h = $sts->fetchrow_hashref(NAME_lc);
         while ( $h = $sts->fetchrow_hashref(NAME_lc) ) {
            $shipaddr = $h->{'shipto'};
            
            
            ## should do something here...
         } # done looking up address
         
         # 		$reg_stat='';
         # 		if ($shipaddr =~ /CR$|RG$/) {
         #    			($shipaddr,$reg_stat) = split /-/, $shipaddr;
         #    			$shipaddr .= "-";
         # 		}
         
         ## get the destination zipcode
         #
         $q = 'SELECT * FROM addresses WHERE ';
         $q.= "objid= " . $dbh->quote($shipaddr);
         $stc = $dbh->prepare( $q );
         $stc->execute;
         
         
#         if ( $stc->rows > 0 ) {
#            $h = $stc->fetchrow_hashref(NAME_lc);
         while ( $h = $stc->fetchrow_hashref(NAME_lc) ) {
            $shipzip = $h->{'postcode'};
            ( $shipzip ) = split /-/, "$shipzip";   # kill zip+4 scruff
            
            ($h->{'firstname'},$h->{'lastname'},$h->{'nametitle'}) = split /\|/,$h->{'name'};
            
            ## we have the address here
            $tmp_output=permutebit($tmp_address_cell,$h);
         } # TBD - should be an else clause...
         
         
         $tmp_hash->{'cell_ck_addressdisplay'}=$tmp_output;
         $tmp_output='';
         
         $stc->finish;
         
         ## we need to get the lines from tcart for the names and prices
         $q = "SELECT * FROM tcart WHERE objclass != '140-A' AND orderid = " . $dbh->quote($orderid);
         $stc=$dbh->prepare($q);
         $stc->execute;
#         $num = $stc->rows;
#         if ($num > 0) {
         $num=0;   
#            foreach (1 .. $num) {
         while ( $h = $stc->fetchrow_hashref(NAME_lc) ) {
               $num=1;
#               $h = $stc->fetchrow_hashref(NAME_lc);
               ## do the vsku stuff
               $h->{'vsku'} = $h->{'msku'} . $h->{'vcode'};
                
               $q = "SELECT * FROM things WHERE objid = '$h->{'lineobjid'}'";
               $sth=$dbh->prepare($q);
               $sth->execute;

               $vcode="";
               $vardescript="";
               
#               if ($sth->rows == 1) {
                  ## we will add everything to the h hashref from the things select
#                  $nh = $sth->fetchrow_hashref(NAME_lc);
               while ( $nh = $sth->fetchrow_hashref(NAME_lc) ) {
                  ## pull title and plaintext variant from msku
                  #
                  
                  if ( $nh->{'objid'} ne $nh->{'ref_from'} && $nh->{'ref_from'} ) {
                     $vcode = $nh->{'vcode'};
                     $q="SELECT * from things where objid='$nh->{'ref_from'}' ";
                     $stq=$dbh->prepare( $q );
                     $stq->execute;
#                     $num=$stq->rows;
                     $mh=$stq->fetchrow_hashref(NAME_lc);

                     @vcodes = split /:/, $vcode;
                     @axisname = split /:/, $mh->{'axisnames'};
                     foreach $axis (@axisname) {
                        $s="SELECT body FROM extraprop WHERE objid='$axis' AND fieldname='encoding'";
                        $stl=$dbh->prepare($s);
                        $stl->execute;
                        ($body)=$stl->fetchrow;
                        @valuepairs = split /\r\n/, $body;
                        foreach $pair (@valuepairs) {
                           ($key,$value) = split/:/, $pair;
                           $variant{$key}=$value;
                        }
                        $code = shift @vcodes;
                        $vardescript.=" ".$variant{$code};
                     }
                     $nh->{'title'} = $mh->{'title'}.$vardescript;

                  }



                  foreach (keys %{$nh}) {
                     ## need to check for variants TODO
                     $h->{$_}=$nh->{$_};
                  }
               }
               next if ($h->{'objclass'} eq '154-A');
         	##check inventory      
               $h->{'rowid'} = $h->{'objid'};

               $h->{'linetotal'} = nicedecimals($h->{'linetotal'});

               # we use a cell that has rowid so we add it to the hash
               $tmp_output .= permutebit ($tmp_cart_cell,$h);
            }
#            } else {
         if ( $num == 0 ) {
            ## whoa this oid doesn't have anything in its cart
            ## probably they went back and deleted stuff
            ## lets not show it and just return
             
            $ret_hash->{'cell_ck_cartlist'} = 'No Items in Cart'; #TODO mesage

            next;
         }
         
         $tmp_hash->{'cell_ck_cartlist'} = $tmp_output;
         $tmp_output='';
         ## here we get the shipping methods
         @methods=list_ship_methods( "USA","$shipzip","$weight"  );
         ## construct the pulldown
         $q="";
         $deliveryflag="no";

      if ( @methods ) {
         ## cell is cell_ck-shipmethod
         $tmp_cell = localize_template("cell_ck_shipmethod", $om_render_lang, "html",0);
         $h->{'checked'} = 'checked';
         ## checked for to return the checked one
         foreach ( @methods ) {
            @temp=split /\t/, $_;
            $h->{'msku'} = $temp[0];
            $h->{'unitpr'} = nicedecimals($temp[1]);
            $h->{'title'} = $temp[2];
            $h->{'orderid'} = $orderid;
            $tmp_output.= permutebit($tmp_cell,$h);
            ## check only the firt one hackish here TODO
            $h->{'checked'} = '' if ($h->{'checked'});
            
         }
      
        $tmp_hash->{'shipnum'} = $shipnum;
         $shipnum++;
         $tmp_hash->{'cell_ck_shipmethod'} = $tmp_output;
         $tmp_hash->{'cell_ck_continue'} = localize_template("cell_ck_shipmethbut", $om_render_lang,"html",0);
         $ret_hash->{'FORM'}->{'cell_ck_shippingmethod'}.=permutebit ($tmp_shippingmethod_cell,$tmp_hash);
         $ret_hash->{'shipwt'} = $weight; 
      } else {
#         $tmp_hash->{'cell_ck_continue'} = localize_template("cell_ck_shipmethbut", $om_render_lang,"html",0);
         $tmp_hash->{'cell_ck_continue'} = "<BR>No Shipping Method Available - take some items out of your cart 
         for now <BR> and then after completing this order, add the items taken out into another order. <BR>
         <BR>Or contact us at <A href=\"mailto:$site->{'order_email_address'}\">$site->{'order_email_address'}</A> for instructions on completing this order.<BR><BR> <a href=http://__siteurl__/html/__om_render_lang__/home.shtml><img src=/images/eng/buttons/returntoshopping.gif  border=0></a>\n";
         $ret_hash->{'FORM'}->{'cell_ck_shippingmethod'}.=permutebit ($tmp_shippingmethod_cell,$tmp_hash);

      }
         $stc->finish;
         $sts->finish;
    
      }
      } elsif ($ret_hash->{'mode'} eq 'APPROVE') {
      ## t4e
      my ($got);
      $got = 0;
      foreach $k (keys %{$ret_hash->{'FORM'}}) {
         my ($oid,$sku,$unitpr,$rowsi,$shipmethod);
         next if ($k !~ /^ORDERID/);
         ($jnk,$orderid) =  split /\./ , $k ;
         $shipmethod = $ret_hash->{'FORM'}->{$k};


         $ret_hash->{'shipmethod'} =$shipmethod;
            $ret_hash->{'shipcost'} = $ret_hash->{'FORM'}->{"PRICEID.$shipmethod"};
          
	$ret_hash = insertShipMethod($ret_hash);	    			
         $got =1;

      }
      
      
      ## now check for gift wrap
      
      
      foreach $k (keys %{$ret_hash->{'FORM'}}) {
         my ($oid,$lineid,$unitpr,$rows);
         
         next if ($k !~ /gift$/);
         next if ($ret_hash->{'FORM'}->{$k} ne 'on');
         
         ($lineid,$jnk) =  split /\./ , $k ;
         
         $q = "UPDATE tcart SET flags='gift' WHERE objid= " . $dbh->quote($lineid);
#         $dbh->do($q);
         $sth = $dbh->prepare( $q );
         $sth->execute;         
         $ret_hash->{'giftset'}=1;
         ##ERROR HANDLING
         
         
         
      }
      if (!$got) {
         $ret_hash->{'ERROR'} = "You must select at least one";
         $ret_hash->{'FORM'}->{'shipmethod_err'} =  "You must select at least one";
      }
      
   }
   ## the delivery method cell...
   #
   
   
   
   ## done constructing ship method
   
   
   ##get all shipping methods from database as per location
   ##if pre seletected one if one of them display that one
   
   
   ##approve
   
   ##simple, just store the shipping method and cost into orders
   
   return $ret_hash;
   
   
}

sub cl_billpay {
   
   ##SHOW
   my ($ret_hash,$loadpoint,@payment_types,$k,$tmp_template,$tmp_output);
   
   $ret_hash = $_[0];
   $loadpoint = "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/site";
   if ($ret_hash->{'mode'} eq 'SHOW') {
      $q=localize_template( "sel_ccname", $om_render_lang,"html",0 );
      @temp=split /\n/,$q;
      $h->{'CCNAME_SELECT'} = gen_select( $ret_hash->{'FORM'}->{'BILLTYPE.CREDIT.CCNAME_inp'},2,@temp );
      $q=localize_template( "sel_ccexpyr", $om_render_lang,"html",0 );
      @temp=split /\n/,$q;
      $h->{'CCEXPYR_SELECT'} = gen_select($ret_hash->{'FORM'}->{'BILLTYPE.CREDIT.CCEXPYR_inp'},2,@temp );
      
      $q=localize_template( "sel_ccexpmo",$om_render_lang,"html",0 );
      @temp=split /\n/,$q;
      $h->{'CCEXPMO_SELECT'} = gen_select( $ret_hash->{'FORM'}->{'BILLTYPE.CREDIT.CCEXPMO_inp'},2,@temp );
      #@payment_types = GetPaymentTypes();
	$payment_types[0] = 'credit';
      foreach $k (@payment_types) {
         $tmp_template = localize_template("cell_ck_".$k."_form", $om_render_lang,"html",0);
         $tmp_template = permutebit ($tmp_template,$h);
         $tmp_template = permutebit ($tmp_template,$ret_hash->{'FORM'});
         
         $tmp_output .= $tmp_template;
      }
      $ret_hash->{'FORM'}->{'cell_ck_billpay'} = $tmp_output;
      } elsif ($ret_hash->{'mode'} eq 'APPROVE') {
      foreach $k (keys %{$ret_hash->{'FORM'}}) {
         
         next if ($k !~ /^BILLTYPE/);
         next if ($ret_hash->{'FORM'}->{$k} ne 'on');
         push (@payment_select, $k);
      }
      $count = 0;
      
      if (!@payment_select ) {
         $ret_hash->{'ERROR'} = "You have to Select at least one\n";
         $ret_hash->{'FORM'}->{'PAYMENT_err'} = $ret_hash->{'ERROR'};
      }
      foreach $k (@payment_select) {
         if ($count > 1) {
            $ret_hash->{'ERROR'} = "You can't use more than one payment type";
            $ret_hash->{'FORM'}->{'PAYMENT_err'} = "You can't use more than one payment type";
         }
         next if ($ret_hash->{'ERROR'});
         if ($k =~ /CREDIT/) {
            $tmp_string = '';
            foreach $kn (keys %{$ret_hash->{'FORM'}}) {
               
               next if ($kn !~ /CREDIT/);
               next if ($kn !~ /_inp$/);
               @tmp = split /\./, $kn;
               
               $h->{'$tmp[2]'}=$ret_hash->{'FORM'}->{$kn};
               
               $tmp_string .= "," if ($tmp_string);
               
               $tmp_string .= "$tmp[2]"."=".$ret_hash->{'FORM'}->{$kn};
               $h->{$tmp[2]} = $ret_hash->{'FORM'}->{$kn};
            }
            $rv = validate_payment($h);

                        
            
            if ($rv->{'CC_err'}) {
               $ret_hash->{'ERROR'} = $rv->{'CC_err'};
               $ret_hash->{'FORM'}->{'PAYMENT_err'} = $rv->{'CC_err'};
               foreach $ky (keys %{$rv}) {
                  $ret_hash->{'FORM'}->{"$k.$ky"}=$rv->{$ky};
               }
                  $ret_hash->{'FORM'}->{"BILLTYPE.CREDIT.CCID_inp"}="";
                  $ret_hash->{'FORM'}->{"BILLTYPE.CREDIT.CCEXPYR_inp"}="";
                  $ret_hash->{'FORM'}->{"BILLTYPE.CREDIT.CCEXPMO_inp"}="";    
                  $ret_hash->{'FORM'}->{"BILLTYPE.CREDIT.CCNAME_inp"}="";
                  $ret_hash->{'FORM'}->{'name'}="";
               } else {
                 &storecc($h,$ret_hash->{'orderid'});
            }
         } ## I think we have to compute this here
      }
   }
   
   return $ret_hash;
   ##display list of payment types
   ##and error messages if any
   
   
   
   ##APPROVE
   
   ##do simple check on payment field (payment .pm?)
   ##store data in database
   
}


sub cl_orderlist {
   
   
   
   my ($ret_hash,$func,$tmp_hash,$tmp_output,$tmp_cellhash);
   $ret_hash = $_[0];
   $func = $ret_hash->{'FORM'}->{'func'};
   if ($ret_hash->{'mode'} eq 'SHOW') {
      
      ##SHOW
      ##figure out how much we want to show
      ##BILL,SHIP,APPROVE
      
      if ($func eq 'firstdisplay') {
         # we need to display the address only
         
         $tmp_cell = localize_template('cell_orderlist_cart', $om_render_lang,"html",0);
         $q = "SELECT * from tcart where objclass='134-A' and sid = " . $dbh->quote($ret_hash->{'sid'});
         $sth=$dbh->prepare($q);
         $sth->execute;
#         $rows=$sth->rows;
         
#         if ($rows > 0) {
#            foreach ($rows) {
#               $h = $sth->fetchrow_hashref(NAME_lc);
         if ( $h = $sth->fetchrow_hashref(NAME_lc) ) {
          

               #$h =  depreciate_inventory($h);
	       if ($h->{'ERR'} && (!$h->{'HQUANT'})) {
			$h->{'ERR'} .= "<br>This row will be deleted from your cart";
			$q = "delete from tcart where objid = '$h->{'objid'}'";
#			$dbh->do($q);
                        $sth = $dbh->prepare( $q );
                        $sth->execute;
               }

               $q = "SELECT * from things where objid=" . $dbh->quote($h->{'lineobjid'});
               $stf=$dbh->prepare($q);
               $stf->execute;
#               $num=$stf->rows;
#               if ($num == 1 ) {
#                  $nh=$stf->fetchrow_hashref(NAME_lc);
               if ( $nh=$stf->fetchrow_hashref(NAME_lc) ) {
                  ## pull title and plaintext variant from msku
                  #  

                  if ( $nh->{'objid'} ne $nh->{'ref_from'} && $nh->{'ref_from'} ) {
                     $vcode = $nh->{'vcode'};
                     $q="SELECT * from things where objid='$nh->{'ref_from'}' ";
                     $stq=$dbh->prepare( $q );
                     $stq->execute;
#                     $num=$stq->rows;
                     $mh=$stq->fetchrow_hashref(NAME_lc);

                     @vcodes = split /:/, $vcode;
                     @axisname = split /:/, $mh->{'axisnames'};
                     foreach $axis (@axisname) {
                        $s="SELECT body FROM extraprop WHERE objid='$axis' AND fieldname='encoding'";
                        $stl=$dbh->prepare($s);
                        $stl->execute;
                        ($body)=$stl->fetchrow;
                        @valuepairs = split /\r\n/, $body;
                        foreach $pair (@valuepairs) {
                           ($key,$value) = split/:/, $pair;
                           $variant{$key}=$value;
                        }
                        $code = shift @vcodes;
                        $vardescript.=" ".$variant{$code};
                     }
                     $nh->{'title'} = $mh->{'title'}.$vardescript;

                  }  

                  foreach (keys %{$nh}) {
                     $h->{$_}=$nh->{$_};
                  }
               }

               $h->{'linetotal'} = nicedecimals($h->{'linetotal'});

               ##TODO insert shipping lenght here
               $tmp_output.= permutebit ($tmp_cell,$h);
            }
#         }
         
         $tmp_cellhash->{'cell_ck_cartdisplay_list'} =$tmp_output;
         
         $sth->finish;
         
      } elsif ($func eq 'billto') {
         
         ## permute whole page
         # we need to display the address shipping price and info
         
         my ($oid);
         $shipnum =1;
         $tmp_approve_ship = localize_template('cell_ck_addresslist_shipto', $om_render_lang,"html",0);
         foreach $oid (@{$ret_hash->{'orderid_array'}}) {
            
            $discount = 0;
            $main_out_template = localize_template('cell_ck_allorder', $om_render_lang,"html",0);
            $q = "SELECT  SHIPTO,BILLTO from orders where objid = " . $dbh->quote($oid);
            $sth=$dbh->prepare($q);
            $sth->execute;
#            $rows = $sth->rows;
            
#            if ($rows ==1 ) {
#               ($shipto,$billto) = $sth->fetchrow;
            if ( ($shipto,$billto) = $sth->fetchrow ) {
               $q = "SELECT * from addresses where objid = '$shipto'";
               $sth=$dbh->prepare($q);
               $sth->execute;
#               $rows=$sth->rows;
#               if ($rows == 1) {
                  
#                  $h = $sth->fetchrow_hashref(NAME_lc);
                if ( $h = $sth->fetchrow_hashref(NAME_lc) ) {
                  $shipstate =$h->{'state'};
                  ($h->{'firstname'},$h->{'lastname'},$h->{'nametitle'}) = split /\|/,$h->{'name'};
               }
            }
            
            $tmp_cellhash->{'cell_addresses_ship'} = permutebit($tmp_approve_ship, $h);
            $tmp_cell = localize_template('cell_ck_cartdisplay_list', $om_render_lang,"html",0);
            $sth->finish;
            
            
            $q = "SELECT title FROM things WHERE objid=" . $dbh->quote($shipsku);
            $sth=$dbh->prepare($q);
            $sth->execute;
#            $rows=$sth->rows;
#            if ($rows > 0 ) {
#               $shiptitle = $sth->fetchrow;
            if ( $shiptitle = $sth->fetchrow ) {

            }
            
            
            $sth->finish;
            
            $q = "SELECT * from tcart where orderid = " . $dbh->quote($orderid);
            $sth=$dbh->prepare($q);
            $sth->execute;
            $rows=$sth->rows;
            $tmp_output='';
            $taxtotal = 0;
            $notaxtotal = 0;
#            if ($rows > 0) {
#               for (1 .. $rows) {
#                  $h = $sth->fetchrow_hashref(NAME_lc);
            $num=0;
             while ( $h = $sth->fetchrow_hashref(NAME_lc) ) {
                  $num=1;    
                  $q = "SELECT * from things where objid=" . $dbh->quote($h->{'lineobjid'});
                  $stf=$dbh->prepare($q);
                  $stf->execute;
#                  $num=$stf->rows;
#                  if ($num == 1 ) {
                  if ( $nh=$stf->fetchrow_hashref(NAME_lc) ) {
                     $vcode="";
                     $vardescript="";
#                     $nh=$stf->fetchrow_hashref(NAME_lc);

                     ## pull title and plaintext variant from msku
                     #  

                     if ( $nh->{'objid'} ne $nh->{'ref_from'} && $nh->{'ref_from'} ) {
                        $vcode = $nh->{'vcode'};
                        $q="SELECT * from things where objid='$nh->{'ref_from'}' ";
                        $stq=$dbh->prepare( $q );
                        $stq->execute;
#                        $num=$stq->rows;
                        $mh=$stq->fetchrow_hashref(NAME_lc);

                        @vcodes = split /:/, $vcode;
                        @axisname = split /:/, $mh->{'axisnames'};
                        foreach $axis (@axisname) {
                           $s="SELECT body FROM extraprop WHERE objid='$axis' AND fieldname='encoding'";
                           $stl=$dbh->prepare($s);
                           $stl->execute;
                           ($body)=$stl->fetchrow;
                           @valuepairs = split /\r\n/, $body;
                           foreach $pair (@valuepairs) {
                              ($key,$value) = split/:/, $pair;
                              $variant{$key}=$value;
                           }
                           $code = shift @vcodes;
                           $vardescript.=" ".$variant{$code};
                        }
                        $nh->{'title'} = $mh->{'title'}.$vardescript;

                     }    

                     foreach (keys %{$nh}) {
                        $h->{$_}=$nh->{$_};
                     }
                  }
                #  next if ($h->{'objclass'} ne '134-A'); #not implented in test data
                  
                  $h->{'VSKU'} = $h->{'SKU'} . $h->{'VCODE'};
                  ##TODO insert shipping lenght here

                  if ($h->{'objclass'} =~ '134-') {
                     $taxtotal += $h->{'linetotal'} if ($h->{'taxable'} );
                     $notaxtotal += $h->{'linetotal'} if (!$h->{'taxable'} );
                     $h->{'linetotal'}=nicedecimals($h->{'linetotal'});
                     $tmp_output .= permutebit ($tmp_cell,$h);
		  } elsif ($h->{'objclass'} eq '140-A') {
		     $shiptitle = $h->{'title'};
                     $shipcost = $h->{'linetotal'};
                  }
                  $stf->finish;
               }
#               } else {
               if ( $num == 0 ) {
               next;
            }
            $sth->finish;

            ## this is a easy way out of the tax rate problem
            ## it should be fixed for a taxrate table

            if ($shipstate eq $site->{'storestate'}) {
               $taxrate = $site->{'taxrate'};
               } else {
               $taxrate =0 ;
            }
            $tax = $taxtotal * ($taxrate/100);
            $tax = nicedecimals($tax); 
            $subtotal = $tax + $taxtotal + $notaxtotal + $shipcost + $discount;
            $subtotal = nicedecimals($subtotal); 
            $q= "update orders set TAXRATE = " . $dbh->quote($taxrate) . ", ST_TAX = " . $dbh->quote($tax) . " , ST_TAXABLE = " . $dbh->quote($taxtotal) . ", ";
            $q.= "ST_NONTAX = " . $dbh->quote($notaxtotal) . ", ORDTOTAL = " . $dbh->quote($subtotal) . " where objid = " . $dbh->quote($oid);
#            $dbh->do($q);
            $sth = $dbh->prepare( $q );
            $sth->execute;
            $tmp_orderlist =  localize_template('cell_ck_smallorder', $om_render_lang,"html",0);
            $q = "SELECT * from orders where objid = " . $dbh->quote($oid);
            $sth=$dbh->prepare($q);
            $sth->execute;
#            $rows=$sth->rows;
#            if ($rows == 1) {
#               $tmp_order = $sth->fetchrow_hashref(NAME_lc);
            if ( $tmp_order = $sth->fetchrow_hashref(NAME_lc) ) {               
               
               foreach $k (keys %{$tmp_order}) {
                  $tmp_order->{$k} = nicedecimals($tmp_order->{$k});
               }
               
            }
            $tmp_order->{'shippingmethod'}=$shiptitle;
            $tmp_order->{'shipcost'}=nicedecimals($shipcost);
            $tmp_order->{'itemcost'} = nicedecimals($taxtotal + $notaxtotal);
            $tmp_order->{'subtotal'} = nicedecimals($taxtotal + $notaxtotal );
            
            $tmp_output = permutebit ($tmp_output, $tmp_order);
            $tmp_cellhash->{'cell_cartlist'} = $tmp_output;
            $tmp_cellhash->{'cell_orderlist'} = permutebit ($tmp_orderlist, $tmp_order);
            $sth->finish;
            
            $ret_hash->{'FORM'}->{'cell_ck_shiptocart_list'} .= permutebit ($main_out_template,$tmp_cellhash);
         }
         
         } elsif ($func eq 'APPROVE') {
         
         # we need to display the address shipping price and info
         
         my ($oid);
         $shipnum = 1;
         $main_out_template = localize_template('cell_ck_allorder', $om_render_lang,"html",0);
         $tmp_approve_ship = localize_template('cell_ck_addresslist_shipto', $om_render_lang,"html",0);
         $tmp_approve_bill = localize_template('cell_ck_addresslist_bill', $om_render_lang,"html",0);
         foreach $oid (@{$ret_hash->{'orderid_array'}}) {
            $discount=0;
            $q = "SELECT  SHIPTO,BILLTO from orders where objid = " . $dbh->quote($oid);
            $sth=$dbh->prepare($q);
            $sth->execute;
#            $rows = $sth->rows;
            
#            if ($rows ==1 ) {
#               ($shipto,$billto) = $sth->fetchrow;
            if ( ($shipto,$billto) = $sth->fetchrow ) {
               $q = "SELECT * from addresses where objid = '$shipto'";
               $sth=$dbh->prepare($q);
               $sth->execute;
#               $rows=$sth->rows;
#               if ($rows == 1) {
               if ( $h = $sth->fetchrow_hashref(NAME_lc) ) {                  
#                  $h = $sth->fetchrow_hashref(NAME_lc);
                  $shipstate =$h->{'state'};
                  ($h->{'firstname'},$h->{'lastname'},$h->{'nametitle'}) = split /\|/,$h->{'name'};
               }
            }
            $sth->finish;
            
            $tmp_cellhash->{'cell_addresses_ship'} = permutebit($tmp_approve_ship, $h);
            
            
            $q = "SELECT * from addresses where objid =  " . $dbh->quote($billto);

            $sth=$dbh->prepare($q);
            $sth->execute;
#            $rows=$sth->rows;
            
#            if ($rows == 1) {
#               $h = $sth->fetchrow_hashref(NAME_lc);
            if ( $h = $sth->fetchrow_hashref(NAME_lc) ) {
               ($h->{'FIRSTNAME'},$h->{'LASTNAME'},$h->{'NAMETITLE'}) = split /\|/,$h->{'NAME'};
            }
            $sth->finish;
            
            $tmp_cellhash->{'cell_addresses_bill'} = permutebit($tmp_approve_bill, $h);
            $q = "SELECT TITLE from things where objid='$objid'";
            $sth=$dbh->prepare($q);
            $sth->execute;
#            $rows=$sth->rows;
#            if ($rows > 0 ) {
#               $shiptitle = $sth->fetchrow;
            if ( $shiptitle = $sth->fetchrow ) {
            }
            $sth->finish;
            
            $tmp_cell = localize_template('cell_ck_cartdisplay_list', $om_render_lang,"html",0);
            $tmp_cell_noview = localize_template('cell_ck_cartdisplay_list_noview', $om_render_lang,"html",0);
            $q = "SELECT * from tcart where orderid = " . $dbh->quote($oid);
            $sth=$dbh->prepare($q);
            $sth->execute;
#            $rows=$sth->rows;
            $tmp_output='';
            $taxtotal = 0;
            $notaxtotal = 0;
#            if ($rows > 0) {
#               for (1 .. $rows) {
            $num=0;
            if ( $h = $sth->fetchrow_hashref(NAME_lc) ) {
               $num=1;
                  $h = $sth->fetchrow_hashref(NAME_lc);
                  
                  $q = "SELECT * from things where objid= " . $dbh->quote($h->{'lineobjid'});
                  $stf=$dbh->prepare($q);
                  $stf->execute;
#                  $num=$stf->rows;
#                  if ($num == 1 ) {
#                     $nh=$stf->fetchrow_hashref(NAME_lc);
                  if ( $nh=$stf->fetchrow_hashref(NAME_lc) ) {
                     ## pull title and plaintext variant from msku
                     #  

                     if ( $nh->{'objid'} ne $nh->{'ref_from'} && $nh->{'ref_from'} ) {
                        $vcode = $nh->{'vcode'};
                        $q="SELECT * from things where objid='$nh->{'ref_from'}' ";
                        $stq=$dbh->prepare( $q );
                        $stq->execute;
#                        $num=$stq->rows;
                        $mh=$stq->fetchrow_hashref(NAME_lc);

                        @vcodes = split /:/, $vcode;
                        @axisname = split /:/, $mh->{'axisnames'};
                        foreach $axis (@axisname) {
                           $s="SELECT body FROM extraprop WHERE objid='$axis' AND fieldname='encoding'";
                           $stl=$dbh->prepare($s);
                           $stl->execute;
                           ($body)=$stl->fetchrow;
                           @valuepairs = split /\r\n/, $body;
                           foreach $pair (@valuepairs) {
                              ($key,$value) = split/:/, $pair;
                              $variant{$key}=$value;
                           }
                           $code = shift @vcodes;
                           $vardescript.=" ".$variant{$code};
                        }
                        $nh->{'title'} = $mh->{'title'}.$vardescript;

                     }   

                     foreach (keys %{$nh}) {
                        $h->{$_}=$nh->{$_};
                     }
                  }
                  if ($h->{'CARTKIND'} =~ /RULE|GIFT|PRO/) {
                     $h->{'SHIP_TIME'}="N/A";
                  }
                  $h->{'VSKU'} = $h->{'SKU'} . $h->{'VCODE'};
                  ##TODO insert shipping lenght here
             
                  if ($h->{'objclass'} =~ '134-') {
                     $taxtotal += $h->{'linetotal'} if ($h->{'taxable'} );
                     $notaxtotal += $h->{'linetotal'} if (!$h->{'taxable'} );
                     $tmp_output .= permutebit ($tmp_cell,$h);
		  } elsif ($h->{'objclass'} eq '140-A') {
		     $shiptitle = $h->{'title'};
                     $shipcost = $h->{'linetotal'};
                  }
     
                  # Do not allow clicking on Promo items in checkout...
                  if ($nh->{'SKUKIND'} eq 'RULE') {
                     $tmp_output .= permutebit ($tmp_cell_noview,$h);
                     } else {
                     $tmp_output .= permutebit ($tmp_cell,$h);
                  }
                  
               }
#               } else {
            if ( $num == 0 ) {
               next;
            }
            $sth->finish;
             
            if ($shipstate eq $site->{'storestate'}) {
               $taxrate = $site->{'taxrate'};
               } else {
               $taxrate =0 ;
            }
           ##INERT 
            $tax = $taxtotal * ($taxrate/100);
            $tax = nicedecimals($tax);
            $subtotal = $tax + $taxtotal + $notaxtotal + $shipcost + $discount;
            $subtotal = nicedecimals($subtotal);           
 
            $q= "update orders set TAXRATE = '$taxrate', ST_TAX = '$tax' , ST_TAXABLE = '$taxtotal',";
            $q.= "ST_NONTAX = '$notaxtotal', ORDTOTAL = '$subtotal' where OID = '$oid'";
#            $dbh->do($q);
            $sth = $dbh->prepare( $q );
            $sth->execute;
            $tmp_orderlist =  localize_template('cell_ck_bigorder', $om_render_lang,"html",0);
            $q = "SELECT * from orders where oid = " . $dbh->quote($oid);
            $sth=$dbh->prepare($q);
            $sth->execute;
#            $rows=$sth->rows;
#            if ($rows == 1) {
#               $tmp_order = $sth->fetchrow_hashref(NAME_lc);
            if ( $tmp_order = $sth->fetchrow_hashref(NAME_lc) ) {
                
               if ($tmp_order->{'ORDTYPE'} eq 'bk') {
                  $tmp_order->{'SHIP_TIME'} = $tmpoutstock_msg;
                  } else {
                  $tmp_order->{'SHIP_TIME'} = $tmpinstock_msg;
               }
               
               foreach $k (keys %{$tmp_order}) {
                  next if ($k eq 'SHIP_TIME');
                  
                  $tmp_order->{$k} = nicedecimals($tmp_order->{$k});
               }
               
               
            }
            $tmp_order->{'shippingmethod'}=$shiptitle;
            $tmp_order->{'shipcost'}=nicedecimals($shipcost);
            $tmp_order->{'itemcost'} = nicedecimals($taxtotal + $notaxtotal);
            $tmp_order->{'subtotal'} = nicedecimals($taxtotal + $notaxtotal + $wrapcost+$discount);
            
            $tmp_output = permutebit ($tmp_output, $tmp_order);
            $tmp_cellhash->{'shipnum'} = $shipnum;
            $shipnum++;
            $tmp_cellhash->{'cell_cartlist'} = $tmp_output;
            $tmp_cellhash->{'cell_orderlist'} = permutebit ($tmp_orderlist, $tmp_order);
            $sth->finish;
            
            $ret_hash->{'FORM'}->{'cell_ck_shiptocart_list'} .= permutebit ($main_out_template,$tmp_cellhash);
         }
         # we need to display the address and shipping and price
         # we need to display the address only
         
      }
   }
   ##APRROVE
   ## pure display
   ##
   return $ret_hash;
}



sub cl_orderapprove {
   
   ##SHOW
   ##simple little cell, no premutes
   
   
   my ($ret_hash,$output);
   $ret_hash = $_[0];
   if ($ret_hash->{'mode'} eq 'SHOW') {
      ##APPROVE
      ##go back to billpay page with error message
      $output = localize_template('cell_ck_approve_but', $om_render_lang,"html",0);
      $ret_hash->{'cell_ck_approve_but'} = $output;
      
      
      } elsif ($ret_hash->{'mode'} eq 'APPROVE') {
      foreach $oid (@{$ret_hash->{'orderid_array'}}) {
         
      
         next if ($ret_hash->{'ERROR'}  =~ /REFUSAL|DATA_ERROR|SYSTEM_ERROR/ );
         $ret_hash->{'oid'} = $oid;
         foreach $kn (keys %{$ret_hash->{'FORM'}}) {
            
            
            
            next if ($kn !~ /CREDIT/);
            next if ($kn !~ /_inp$/);
            @tmp = split /\./, $kn;
            
            $h->{'$tmp[2]'}=$ret_hash->{'FORM'}->{$kn};
            
            $tmp_string .= "," if ($tmp_string);
            
            $tmp_string .= "$tmp[2]"."=".$ret_hash->{'FORM'}->{$kn};
            $ret_hash->{$tmp[2]} = $ret_hash->{'FORM'}->{$kn};
         }
         foreach (@{$ret_hash->{'orderid_array'}}) {
            next if ($ret_hash->{'ERROR'} =~ /REFUSAL|DATA_ERROR|SYSTEM_ERROR/ );
            $ret_hash->{'oid'} = $_;
	    foreach (keys %{$ret_hash->{'FORM'}}) {
               my $k = $_;
               next if ($_ !~ /_inp$|^BILLTYPE/);
               $k =~ s/_inp//;
               $k =~ s/BILLTYPE\.CREDIT\.//;
               $ret_hash->{$k} = $ret_hash->{'FORM'}->{$_};
	    }
            $q = "SELECT ordtotal from orders where objid = '$_'";
	    $sth=$dbh->prepare($q);
            $sth->execute;
#          my ($rows) = $sth->rows;
#            if ($rows > 0) {
#               $ret_hash->{'ordtotal'} = $sth->fetchrow;
            if ( $ret_hash->{'ordtotal'} = $sth->fetchrow ) {
            } 
            $hash = run_payment ($ret_hash);
            
            $ret_hash->{'ERROR'} = $hash->{'STATUSDVALUE'};
         }
      }
      
   }
   
   
   
   return $ret_hash;
}

sub validatefields {
   # reads hashref
   my(@keys,$k,$hashref,$e,$rv);
   $rv=$_[0];
   $rv->{'ERROR'}='';
   
   # default OK, to 0 if error
   @keys = keys %{$rv};
   while (@keys) {
      
      $k=shift @keys;
      next if ( $k !~ /_inp$/ );
      $kt = $k;
      $kt =~ s/_inp$// ;
     # next if ( $kt =~ /[A-Z]/ );   # fields are all uppercase -- Not True
      $e=validatefield( $kt,$rv->{$k}, $rv );
      if ($e) {
         $rv->{'ERROR'}=1;           # there was an error returned
         $kt.="_err";
         $hashref->{$kt}=$e;   # emplace the error message
      } # done checking for a returned error
   } # done running through form keys
   $rv->{'FORM'}=$hashref;
   return $rv;
}
sub insertShipMethod {

   my ($now,$sth,$num,$shipmethod,$ret_hash);
   $ret_hash = $_[0];
   $now = time();
   $q = "SELECT * FROM tcart WHERE sid='$ret_hash->{'sid'}' and objclass = '140-A' and orderid ='$ret_hash->{'orderid'}'";
   $sth = $dbh->prepare($q);
   $sth->execute;
#   $rows = $sth->rows;
#   if ($rows == 1) {
#      $h = $sth->fetchrow_hashref(NAME_lc);
   if ( $h = $sth->fetchrow_hashref(NAME_lc) ) {
      $q = "update tcart set lineobjid ='$ret_hash->{'shipmethod'}', ";
      $q .= " unitpr = '$ret_hash->{'shipcost'}', linetotal = '$ret_hash->{'shipcost'}',";
      $q .= " mdate = '$now'";
      $q .= " WHERE sid='$ret_hash->{'sid'}' and objclass='140-A' and orderid = '$ret_hash->{'orderid'}'";
#      $dbh->do($q);
      $sth = $dbh->prepare( $q );
      $sth->execute;
#   } elsif ($rows == 0) {
    } else {         
      $dvalue=$FORM->{'sid'}."\tCreate cartID";

      if ( $site->{'site_datadriver'} =~ /Oracle/ ) {

      $l="INSERT into levents (event, DTABLE, DVALUE, CDATE,CUSTID) values(levents_event.nextval,'tcart'," . $dbh->quote($dvalue) . ", " . $dbh->quote($now) . ", " . $dbh->quote($ret_hash->{'custid'}) . ")";
      $stl=$dbh->prepare($l);
      $stl->execute;                                                                                                    $stl->finish;
     
      $q="SELECT levents_event.currval FROM DUAL";
      $stl=$dbh->prepare($q);
      $stl->execute;
      $event=$stl->fetchrow;
 
      } elsif ( $site->{'site_datadriver'} =~ /mysql/ ) {

      $l="INSERT into levents (DTABLE, DVALUE, CDATE,CUSTID) values('tcart'," . $dbh->quote($dvalue) . ", " . $dbh->quote($now) . ", " . $dbh->quote($ret_hash->{'custid'}) . ")";
      $stl=$dbh->prepare($l);
      $stl->execute;
      $stl->finish;
      
      $l="SELECT event, series from levents where DTABLE='tcart' and DVALUE=" . $dbh->quote($dvalue) . " and CDATE = " . $dbh->quote($now) . " ORDER BY event";
      $stl=$dbh->prepare($l);
      $stl->execute;
#      $numl=$stl->rows;
      ($event, $series)=$stl->fetchrow;

      } elsif ( $site->{'site_datadriver'} =~ /Pg/ ) {

       $l="INSERT into levents (event, DTABLE, DVALUE, CDATE,CUSTID) values(NEXTVAL('event'),'tcart'," . $dbh->quote($dvalue) . ", " . $dbh->quote($now) . ", " . $dbh->quote($ret_hash->{'custid'}) . ")";
       $stl=$dbh->prepare($l);
       $stl->execute;
       $stl->finish;

       $q="SELECT CURRVAL('event') FROM levents WHERE DTABLE='tcart' and DVALUE=" . $dbh->quote($dvalue) . " and CDATE = " . $dbh->quote($now) . " ORDER BY event";
       $stl=$dbh->prepare($q);
       $stl->execute;
       $event=$stl->fetchrow;  

      }

      $objid=$event."-".$site->{'series'};
      $stl->finish;
      
      $q = "INSERT into tcart (objid,objclass,sid,custid,orderid,cdate,mdate,lineobjid,unitpr,linetotal,quant)";
      $q .= "values ( '$objid' , '140-A' , '$ret_hash->{'sid'}', '$ret_hash->{'custid'}', '$ret_hash->{'orderid'}'";
      $q .= ", '$now', '$now', '$ret_hash->{'shipmethod'}','$ret_hash->{'shipcost'}', '$ret_hash->{'shipcost'}', '1')";
#      $dbh->do($q);
      $sth = $dbh->prepare( $q );
      $sth->execute;

   }

   return $ret_hash;
}

sub new_addr {
   my($num, $FORM,$name, $q,$rv, $addrid );
   $rv=0;
   $FORM = $_[0];
   $now = time();
   $name = $FORM->{'firstname_inp'}.'|'.$FORM->{'lastname_inp'}.'|'.$FORM->{'nametitle'};

   if ($FORM->{'addrid'}) {  # need to update the record
       $q = "UPDATE addresses SET name = " . $dbh->quote($name);
       $q .= ", address1 = " . $dbh->quote($FORM->{'address1_inp'});
       $q .= " , address2 = " . $dbh->quote($FORM->{'address2_inp'});
       $q .= " , postcode = " . $dbh->quote($FORM->{'postcode_inp'});
       $q .= " , city = " . $dbh->quote($FORM->{'city_inp'});
       $q .= " , dayphone= " . $dbh->quote($FORM->{'dayphone_inp'});
       $q .= " , country= " . $dbh->quote($FORM->{'country_inp'});
       $q .= " , custid= " . $dbh->quote($ret_hash->{'custid'});
       $q .= " WHERE objid = '$FORM->{'addrid'}'";

       $stl = $dbh->prepare($q);
       $stl->execute;
       $rv = $FORM->{'addrid'};
   }
   else {  # new address, so create it
      $dvalue=$FORM->{'sid'}."\tCreate AddressID";
      if ( $site->{'site_datadriver'} =~ /Oracle/ ) { 
	  
	  $l="INSERT INTO levents (event,DTABLE, DVALUE, CDATE,CUSTID) VALUES(levents_event.nextval,'addresses'," . $dbh->quote($dvalue) . ", " . $dbh->quote($now) . ", " . $dbh->quote($ret_hash->{'custid'}) . ")";
	  $stl=$dbh->prepare($l);
	  $stl->execute;
	  $stl->finish;

	  $q="SELECT levents_event.currval FROM DUAL";
	  $stl=$dbh->prepare($q);
	  $stl->execute;
	  $event=$stl->fetchrow;
	  
	  $l="SELECT series FROM levents WHERE DTABLE='addresses' AND DVALUE=" . $dbh->quote($dvalue) . " AND CDATE = " . $dbh->quote($now) . " ORDER BY event";
	  $stl=$dbh->prepare($l);
	  $stl->execute;
	  $series=$stl->fetchrow;
	  
      } elsif ($site->{'site_datadriver'} =~ /mysql/ ) {
	  
	  $dvalue=$FORM->{'sid'}."\tCreate AddressID";
	  $l="INSERT INTO levents (DTABLE, DVALUE, CDATE,CUSTID) VALUES('addresses'," . $dbh->quote($dvalue) . ", " . $dbh->quote($now). ", " . $dbh->quote($ret_hash->{'custid'}) . ")";                                                                                      
	  
	  $stl=$dbh->prepare($l);
	  $stl->execute;
	  $stl->finish;
	  
	  $l="SELECT event, series FROM levents WHERE DTABLE='addresses' AND DVALUE=" . $dbh->quote($dvalue) . " AND CDATE = " . $dbh-> quote($now) . " ORDER BY event";
	  $stl=$dbh->prepare($l);
	  $stl->execute;
	  $numl=$stl->rows;
	  ($event, $series)=$stl->fetchrow;  
      } elsif ( $site->{'site_datadriver'} =~ /Pg/ ) {

           $dvalue=$FORM->{'sid'}."\tCreate AddressID";
           $l="INSERT INTO levents (event,DTABLE, DVALUE, CDATE,CUSTID) VALUES(NEXTVAL('event'),'addresses'," . $dbh->quote($dvalue) . ", " . $dbh->quote($now). ", " . $dbh->quote($ret_hash->{'custid'}) . ")";


           $stl=$dbh->prepare($l);
           $stl->execute;
           $stl->finish;

           $l="SELECT CURRVAL('event'), series FROM levents WHERE DTABLE='addresses' AND DVALUE=" . $dbh->quote($dvalue) . " AND CDATE = " . $dbh-> quote($now) . " ORDER BY event";
           $stl=$dbh->prepare($l);
           $stl->execute;
           $numl=$stl->rows;
           ($event, $series)=$stl->fetchrow;
     }

      $addrid=$event."-".$site->{'series'};

      $q="INSERT INTO addresses ";
      $q.=" (objid, custid, name, address1, address2, city, state, postcode, country, dayphone, cdate, mdate) ";
      $q.=" VALUES ";
      $q.="(" . $dbh->quote($addrid) . ", " . $dbh->quote($ret_hash->{'custid'}) . ", " . $dbh->quote($name) . ", ";
         $q.= $dbh->quote($FORM->{'address1_inp'}) . ", " . $dbh->quote($FORM->{'address2_inp'}) . ",";
         $q.= $dbh->quote($FORM->{'city_inp'}) . ", " . $dbh->quote($FORM->{'state_inp'}) . ",";
      $q.= $dbh->quote($FORM->{'postcode_inp'}) . ",". $dbh->quote($FORM->{'country_inp'}) . " , " . $dbh->quote($FORM->{'dayphone_inp'}) . ", " . $dbh->quote($now) . ", " . $dbh->quote($now) .  ")";
      ## insert the new address
      #
      $stc = $dbh->prepare( $q );
      $stc->execute;
      $rv=$addrid;
      $stc->finish;
      $stl->finish;
   } # done looking to see if this has already been entered

   return $rv;
}


1;





