#!/usr/bin/perl
############################################################################
#    Copyright (C) 1999-2000 Zelerate, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################
#  objects.pm
#  
#  Version 3.0 TG 20000725
#     fixed OBJTYPES to OBJCLASSES for article and product line
#  Version 2.0 TG 20000630
#     changed types of pulldowns and variants
#  Version 1.0 TG 20000628
#
#  To create a hash will known objtypes and objclasses to reference via the
#  cgi scripts.  Should be automatically generated via the initial data
#  load eventually
#

############################################################################
# PURPOSE     Initialize globals for objtypes and objclasses of any
#             that need to be referenced
#
# INPUT       none
#
# OUTPUT      OBJCLASS & OBJTYPES hashrefs
#
# NOTES       This should be moved into a library routine and dynamically
#             generated for all CGI scripts to read in and use.  This will
#             eliminate the need for hardcoding objtypes and objclasses
#             throughout the scripts.  Also, if they ever change, then
#             it will just be changed in one location
############################################################################
sub initClassAndType {
   
   $OBJCLASSES->{'product'} = "134-A";
   $OBJCLASSES->{'product_variant'} = "134-A";
   $OBJCLASSES->{'variant'} = "188-A";
   $OBJCLASSES->{'pulldown'} = "188-A";
   $OBJCLASSES->{'brand'} = "136-A";
   $OBJCLASSES->{'product_line'} = "136-A";
   $OBJCLASSES->{'article'} = "136-A";
   $OBJCLASSES->{'nonproduct'} = "136-A"; 
   $OBJCLASSES->{'internal_doc'} = "136-A";
   $OBJCLASSES->{'warehouse'} = "163-A";


   $OBJTYPES->{'product'} = "45000-A";
   $OBJTYPES->{'product_variant'} = "45000-A";
   $OBJTYPES->{'brand'} = "47004-A";
   $OBJTYPES->{'article'} = "47001-A";
   $OBJTYPES->{'variant'} = "109001-A";
   $OBJTYPES->{'pulldown'} = "109000-A";
   $OBJTYPES->{'product_line'} = "47005-A";
   $OBJTYPES->{'warehouse'} = "74003-A";
   $OBJTYPES->{'internal_doc'} = "47000-A";

}

1;





